zenilib: zenilib/jni/external/freetype2/src/cache/ftcbasic.c File Reference

zenilib 0.5.3.0

- Main Page
- Modules
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Friends Macros Groups Pages
Macros | Typedefs | Functions | Variables
ftcbasic.c File Reference
`#include <ft2build.h>`
`#include <FT_INTERNAL_OBJECTS_H>`
`#include <FT_INTERNAL_DEBUG_H>`
`#include <FT_CACHE_H>`
`#include "ftcglyph.h"`
`#include "ftcimage.h"`
`#include "ftcsbits.h"`
`#include "ftccback.h"`
`#include "ftcerror.h"`

Go to the source code of this file.

## Macros

#define | FT_COMPONENT trace_cache
#define | FTC_BASIC_ATTR_COMPARE(a, b)
#define | FTC_BASIC_ATTR_HASH(a) ( FTC_SCALER_HASH( &(a)->scaler ) + 31*(a)->load_flags )

## Typedefs

typedef struct FTC_BasicAttrRec_ | FTC_BasicAttrRec
typedef struct FTC_BasicAttrRec_ * | FTC_BasicAttrs
typedef struct FTC_BasicFamilyRec_ * | FTC_BasicFamily
typedef struct FTC_BasicFamilyRec_ | FTC_BasicFamilyRec
typedef struct FTC_BasicQueryRec_ * | FTC_BasicQuery
typedef struct FTC_BasicQueryRec_ | FTC_BasicQueryRec

## Functions

| ftc_basic_family_compare (FTC_MruNode ftcfamily, FT_Pointer ftcquery)
| ftc_basic_family_get_count (FTC_Family ftcfamily, FTC_Manager manager)
| ftc_basic_family_init (FTC_MruNode ftcfamily, FT_Pointer ftcquery, FT_Pointer ftccache)
| ftc_basic_family_load_bitmap (FTC_Family ftcfamily, FT_UInt gindex, FTC_Manager manager, FT_Face *aface)
| ftc_basic_family_load_glyph (FTC_Family ftcfamily, FT_UInt gindex, FTC_Cache cache, FT_Glyph *aglyph)
| ftc_basic_gnode_compare_faceid (FTC_Node ftcgnode, FT_Pointer ftcface_id, FTC_Cache cache, FT_Bool *list_changed)
| FTC_ImageCache_Lookup (FTC_ImageCache cache, FTC_ImageType type, FT_UInt gindex, FT_Glyph *aglyph, FTC_Node *anode)
| FTC_ImageCache_LookupScaler (FTC_ImageCache cache, FTC_Scaler scaler, FT_ULong load_flags, FT_UInt gindex, FT_Glyph *aglyph, FTC_Node *anode)
| FTC_ImageCache_New (FTC_Manager manager, FTC_ImageCache *acache)
| FTC_SBitCache_Lookup (FTC_SBitCache cache, FTC_ImageType type, FT_UInt gindex, FTC_SBit *ansbit, FTC_Node *anode)
| FTC_SBitCache_LookupScaler (FTC_SBitCache cache, FTC_Scaler scaler, FT_ULong load_flags, FT_UInt gindex, FTC_SBit *ansbit, FTC_Node *anode)
| FTC_SBitCache_New (FTC_Manager manager, FTC_SBitCache *acache)

## Variables

FT_CALLBACK_TABLE_DEF const FTC_GCacheClassRec | ftc_basic_image_cache_class
FT_CALLBACK_TABLE_DEF const FTC_IFamilyClassRec | ftc_basic_image_family_class
FT_CALLBACK_TABLE_DEF const FTC_GCacheClassRec | ftc_basic_sbit_cache_class
FT_CALLBACK_TABLE_DEF const FTC_SFamilyClassRec | ftc_basic_sbit_family_class

## Macro Definition Documentation

#define FT_COMPONENT trace_cache

Definition at line 30 of file ftcbasic.c.

#define FTC_BASIC_ATTR_COMPARE | ( |  | a,
|  |  | b
| ) |  |

Value:
FT_BOOL( FTC_SCALER_COMPARE( &(a)->scaler, &(b)->scaler ) && \
(a)->load_flags == (b)->load_flags )
a
GLboolean GLboolean GLboolean GLboolean a
Definition: glew.h:8736
FTC_SCALER_COMPARE
#define FTC_SCALER_COMPARE(a, b)
Definition: ftcmanag.h:154
FT_BOOL
#define FT_BOOL(x)
Definition: fttypes.h:581
b
GLdouble GLdouble GLdouble b
Definition: glew.h:8383

Definition at line 82 of file ftcbasic.c.

Referenced by ftc_basic_family_compare().

#define FTC_BASIC_ATTR_HASH | ( |  | a | ) | ( FTC_SCALER_HASH( &(a)->scaler ) + 31*(a)->load_flags )

Definition at line 86 of file ftcbasic.c.

Referenced by FTC_ImageCache_Lookup(), FTC_ImageCache_LookupScaler(), FTC_SBitCache_Lookup(), and FTC_SBitCache_LookupScaler().

## Typedef Documentation

typedef struct FTC_BasicAttrRec_ FTC_BasicAttrRec

typedef struct FTC_BasicAttrRec_ * FTC_BasicAttrs

typedef struct FTC_BasicFamilyRec_ * FTC_BasicFamily

typedef struct FTC_BasicFamilyRec_ FTC_BasicFamilyRec

typedef struct FTC_BasicQueryRec_ * FTC_BasicQuery

typedef struct FTC_BasicQueryRec_ FTC_BasicQueryRec

## Function Documentation

ftc_basic_family_compare | ( | FTC_MruNode | ftcfamily,
|  | FT_Pointer | ftcquery
| ) |  |

Definition at line 107 of file ftcbasic.c.

References FTC_BASIC_ATTR_COMPARE.

Referenced by FTC_ImageCache_Lookup(), FTC_ImageCache_LookupScaler(), FTC_SBitCache_Lookup(), and FTC_SBitCache_LookupScaler().

ftc_basic_family_get_count | ( | FTC_Family | ftcfamily,
|  | FTC_Manager | manager
| ) |  |

Definition at line 135 of file ftcbasic.c.

References error, FT_TRACE1, FT_UINT_MAX, FTC_Manager_LookupFace(), and FT_FaceRec_::num_glyphs.

ftc_basic_family_init | ( | FTC_MruNode | ftcfamily,
|  | FT_Pointer | ftcquery,
|  | FT_Pointer | ftccache
| ) |  |

Definition at line 119 of file ftcbasic.c.

References FTC_FAMILY, and FTC_Family_Init().

ftc_basic_family_load_bitmap | ( | FTC_Family | ftcfamily,
|  | FT_UInt | gindex,
|  | FTC_Manager | manager,
|  | FT_Face * | aface
| ) |  |

Definition at line 164 of file ftcbasic.c.

References error, FT_SizeRec_::face, FT_Load_Glyph(), FT_LOAD_RENDER, and FTC_Manager_LookupSize().

ftc_basic_family_load_glyph | ( | FTC_Family | ftcfamily,
|  | FT_UInt | gindex,
|  | FTC_Cache | cache,
|  | FT_Glyph * | aglyph
| ) |  |

Definition at line 191 of file ftcbasic.c.

References error, FT_SizeRec_::face, FT_GlyphSlotRec_::format, FT_Get_Glyph(), FT_GLYPH_FORMAT_OUTLINE, FT_Load_Glyph(), FTC_Manager_LookupSize(), and FT_FaceRec_::glyph.

ftc_basic_gnode_compare_faceid | ( | FTC_Node | ftcgnode,
|  | FT_Pointer | ftcface_id,
|  | FTC_Cache | cache,
|  | FT_Bool * | list_changed
| ) |  |

Definition at line 239 of file ftcbasic.c.

References FALSE, FTC_GNodeRec_::family, FT_Bool, FT_BOOL, FTC_FaceID, FTC_GNode_UnselectFamily(), and if().

FTC_ImageCache_Lookup | ( | FTC_ImageCache | cache,
|  | FTC_ImageType | type,
|  | FT_UInt | gindex,
|  | FT_Glyph * | aglyph,
|  | FTC_Node * | anode
| ) |  |

Definition at line 316 of file ftcbasic.c.

References error, FT_INT_MIN, FT_TRACE1, FT_UINT_MAX, FTC_BASIC_ATTR_HASH, ftc_basic_family_compare(), FTC_GCACHE, FTC_GCACHE_LOOKUP_CMP, FTC_GNode_Compare(), FTC_GQUERY, FTC_INODE, NULL, and FTC_NodeRec_::ref_count.

FTC_ImageCache_LookupScaler | ( | FTC_ImageCache | cache,
|  | FTC_Scaler | scaler,
|  | FT_ULong | load_flags,
|  | FT_UInt | gindex,
|  | FT_Glyph * | aglyph,
|  | FTC_Node * | anode
| ) |  |

Definition at line 411 of file ftcbasic.c.

References error, FT_TRACE1, FT_UINT_MAX, FTC_BASIC_ATTR_HASH, ftc_basic_family_compare(), FTC_GCACHE_LOOKUP_CMP, FTC_GNode_Compare(), FTC_INODE, NULL, and FTC_NodeRec_::ref_count.

FTC_ImageCache_New | ( | FTC_Manager | manager,
|  | FTC_ImageCache * | acache
| ) |  |

Definition at line 305 of file ftcbasic.c.

References FTC_GCache_New().

FTC_SBitCache_Lookup | ( | FTC_SBitCache | cache,
|  | FTC_ImageType | type,
|  | FT_UInt | gindex,
|  | FTC_SBit * | ansbit,
|  | FTC_Node * | anode
| ) |  |

Definition at line 654 of file ftcbasic.c.

References error, FT_INT_MIN, FT_TRACE1, FT_UINT_MAX, FTC_BASIC_ATTR_HASH, ftc_basic_family_compare(), FTC_GCACHE, FTC_GCACHE_LOOKUP_CMP, FTC_GNODE, FTC_GQUERY, FTC_SBIT_ITEMS_PER_NODE, FTC_SNODE, FTC_SNode_Compare(), NULL, and FTC_NodeRec_::ref_count.

FTC_SBitCache_LookupScaler | ( | FTC_SBitCache | cache,
|  | FTC_Scaler | scaler,
|  | FT_ULong | load_flags,
|  | FT_UInt | gindex,
|  | FTC_SBit * | ansbit,
|  | FTC_Node * | anode
| ) |  |

Definition at line 750 of file ftcbasic.c.

References error, FT_TRACE1, FT_UINT_MAX, FTC_BASIC_ATTR_HASH, ftc_basic_family_compare(), FTC_GCACHE_LOOKUP_CMP, FTC_GNODE, FTC_SBIT_ITEMS_PER_NODE, FTC_SNODE, FTC_SNode_Compare(), NULL, and FTC_NodeRec_::ref_count.

FTC_SBitCache_New | ( | FTC_Manager | manager,
|  | FTC_SBitCache * | acache
| ) |  |

Definition at line 643 of file ftcbasic.c.

References FTC_GCache_New().

## Variable Documentation

FT_CALLBACK_TABLE_DEF const FTC_GCacheClassRec ftc_basic_image_cache_class

Initial value:
=
{
{
ftc_inode_new,
ftc_inode_weight,
ftc_gnode_compare,
ftc_basic_gnode_compare_faceid,
ftc_inode_free,
sizeof ( FTC_GCacheRec ),
ftc_gcache_init,
ftc_gcache_done
},
(FTC_MruListClass)&ftc_basic_image_family_class
}
ftc_gnode_compare
ftc_gnode_compare(FTC_Node gnode, FT_Pointer gquery, FTC_Cache cache, FT_Bool *list_changed)
Definition: ftcglyph.c:66
FTC_GCacheRec
struct FTC_GCacheRec_ FTC_GCacheRec
ftc_basic_image_family_class
FT_CALLBACK_TABLE_DEF const FTC_IFamilyClassRec ftc_basic_image_family_class
Definition: ftcbasic.c:271
ftc_inode_free
ftc_inode_free(FTC_Node inode, FTC_Cache cache)
Definition: ftcimage.c:30
ftc_inode_weight
ftc_inode_weight(FTC_Node inode, FTC_Cache cache)
Definition: ftcimage.c:107
ftc_basic_gnode_compare_faceid
ftc_basic_gnode_compare_faceid(FTC_Node ftcgnode, FT_Pointer ftcface_id, FTC_Cache cache, FT_Bool *list_changed)
Definition: ftcbasic.c:239
ftc_inode_new
ftc_inode_new(FTC_Node *pinode, FT_Pointer gquery, FTC_Cache cache)
Definition: ftcimage.c:94
ftc_gcache_done
ftc_gcache_done(FTC_Cache cache)
Definition: ftcglyph.c:153
ftc_gcache_init
ftc_gcache_init(FTC_Cache cache)
Definition: ftcglyph.c:119
FTC_MruListClass
struct FTC_MruListClassRec_ const * FTC_MruListClass
Definition: ftcmru.h:86

Definition at line 285 of file ftcbasic.c.

FT_CALLBACK_TABLE_DEF const FTC_IFamilyClassRec ftc_basic_image_family_class

Initial value:
=
{
{
sizeof ( FTC_BasicFamilyRec ),
ftc_basic_family_compare,
ftc_basic_family_init,
0,
0
},
ftc_basic_family_load_glyph
}
ftc_basic_family_compare
ftc_basic_family_compare(FTC_MruNode ftcfamily, FT_Pointer ftcquery)
Definition: ftcbasic.c:107
FTC_BasicFamilyRec
struct FTC_BasicFamilyRec_ FTC_BasicFamilyRec
ftc_basic_family_init
ftc_basic_family_init(FTC_MruNode ftcfamily, FT_Pointer ftcquery, FT_Pointer ftccache)
Definition: ftcbasic.c:119
ftc_basic_family_load_glyph
ftc_basic_family_load_glyph(FTC_Family ftcfamily, FT_UInt gindex, FTC_Cache cache, FT_Glyph *aglyph)
Definition: ftcbasic.c:191

Definition at line 271 of file ftcbasic.c.

FT_CALLBACK_TABLE_DEF const FTC_GCacheClassRec ftc_basic_sbit_cache_class

Initial value:
=
{
{
ftc_snode_new,
ftc_snode_weight,
ftc_snode_compare,
ftc_basic_gnode_compare_faceid,
ftc_snode_free,
sizeof ( FTC_GCacheRec ),
ftc_gcache_init,
ftc_gcache_done
},
(FTC_MruListClass)&ftc_basic_sbit_family_class
}
FTC_GCacheRec
struct FTC_GCacheRec_ FTC_GCacheRec
ftc_snode_weight
ftc_snode_weight(FTC_Node snode, FTC_Cache cache)
Definition: ftcsbits.c:279
ftc_snode_compare
ftc_snode_compare(FTC_Node snode, FT_Pointer gquery, FTC_Cache cache, FT_Bool *list_changed)
Definition: ftcsbits.c:325
ftc_snode_new
ftc_snode_new(FTC_Node *psnode, FT_Pointer gquery, FTC_Cache cache)
Definition: ftcsbits.c:266
ftc_basic_gnode_compare_faceid
ftc_basic_gnode_compare_faceid(FTC_Node ftcgnode, FT_Pointer ftcface_id, FTC_Cache cache, FT_Bool *list_changed)
Definition: ftcbasic.c:239
ftc_gcache_done
ftc_gcache_done(FTC_Cache cache)
Definition: ftcglyph.c:153
ftc_snode_free
ftc_snode_free(FTC_Node snode, FTC_Cache cache)
Definition: ftcsbits.c:65
ftc_gcache_init
ftc_gcache_init(FTC_Cache cache)
Definition: ftcglyph.c:119
FTC_MruListClass
struct FTC_MruListClassRec_ const * FTC_MruListClass
Definition: ftcmru.h:86
ftc_basic_sbit_family_class
FT_CALLBACK_TABLE_DEF const FTC_SFamilyClassRec ftc_basic_sbit_family_class
Definition: ftcbasic.c:608

Definition at line 623 of file ftcbasic.c.

FT_CALLBACK_TABLE_DEF const FTC_SFamilyClassRec ftc_basic_sbit_family_class

Initial value:
=
{
{
sizeof ( FTC_BasicFamilyRec ),
ftc_basic_family_compare,
ftc_basic_family_init,
0,
0
},
ftc_basic_family_get_count,
ftc_basic_family_load_bitmap
}
ftc_basic_family_get_count
ftc_basic_family_get_count(FTC_Family ftcfamily, FTC_Manager manager)
Definition: ftcbasic.c:135
ftc_basic_family_load_bitmap
ftc_basic_family_load_bitmap(FTC_Family ftcfamily, FT_UInt gindex, FTC_Manager manager, FT_Face *aface)
Definition: ftcbasic.c:164
ftc_basic_family_compare
ftc_basic_family_compare(FTC_MruNode ftcfamily, FT_Pointer ftcquery)
Definition: ftcbasic.c:107
FTC_BasicFamilyRec
struct FTC_BasicFamilyRec_ FTC_BasicFamilyRec
ftc_basic_family_init
ftc_basic_family_init(FTC_MruNode ftcfamily, FT_Pointer ftcquery, FT_Pointer ftccache)
Definition: ftcbasic.c:119

Definition at line 608 of file ftcbasic.c.